// Prima di caricare il programma, selezionare Strumenti > Scheda > Arduino Uno e Strumenti > Porta > selezionare la porta visibile
// Caricare il programma finito su Arduino schiacciando la freccetta in alto a sinistra
// Visualizzare il monitor seriale schiacciando la lente d'ingrandimento in alto a destra

// MISURE DI DISTANZA - CONVERSIONE GIA' FATTA
// Questo programma effettua un certo numero di misure di tempo consecutive e le converte automaticamente in distanze.
// Le misure iniziano non appena si apre il monitor seriale. Ogni misura viene stampata sul monitor seriale.

#define TRIG -   // Al posto dei trattini, inserire il numero del pin di Arduino a cui è collegato TRIG del sensore (es. 2)
#define ECHO -   // Al posto dei trattini, inserire il numero del pin di Arduino a cui è collegato ECHO del sensore (es. 4)

void setup() {
  Serial.begin(9600);
  analogReference(EXTERNAL);
  pinMode(TRIG, OUTPUT);
  pinMode(ECHO, INPUT);
  digitalWrite(TRIG, LOW);
  Serial.println("Distanza (cm)");
  int i=0;
  float temperatura=0.;
  float distanza=0.;                      
  // unsigned long tempo_inizio = micros();                 // Togliere le barre se si vuole calcolare il tempo di risposta di Arduino (in microsecondi)
  // Serial.println("INIZIO: " + String(tempo_inizio));     // Togliere le barre se si vuole stampare sul monitor seriale il tempo di risposta di Arduino
  
  for (i; i<--; i++) {                                      // Al posto dei trattini, inserire il numero di misure che si vogliono effettuare (es. 100)
    digitalWrite(TRIG, HIGH);  
    delayMicroseconds(10);
    digitalWrite(TRIG, LOW);
    unsigned long Dt = pulseIn(ECHO, HIGH);
    distanza = 343*Dt*(1.e-4)/2.;
    Serial.println(distanza);
    delay(10);                    // Il numero tra parentesi indica i microsecondi di pausa tra una misura e la successiva; possono essere modificati a piacere per accorciare o allungare la pausa
}

void loop() {

}
