// Prima di caricare il programma, selezionare Strumenti > Scheda > Arduino Uno e Strumenti > Porta > selezionare la porta visibile
// Caricare il programma finito su Arduino schiacciando la freccetta in alto a sinistra
// Visualizzare il monitor seriale schiacciando la lente d'ingrandimento in alto a destra

// MEDIE DI MISURE DI DISTANZA CON TEMPI DI ESECUZIONE DELLE MISURE
// Questo programma effettua un dato numero di misure, che vengono automaticamente convertite in distanze, ne calcola la media e poi riprende da capo. In tutto viene calcolato un numero definito di medie.
// Ogni misura di distanza è accompagnata dall'istante di tempo (in secondi) al quale essa viene effettuata.
// Le misure iniziano non appena si apre il monitor seriale. Ogni media viene stampata sul monitor seriale.

#define TRIG -   // Al posto dei trattini, inserire il numero del pin di Arduino a cui è collegato TRIG del sensore (es. 2)
#define ECHO -   // Al posto dei trattini, inserire il numero del pin di Arduino a cui è collegato ECHO del sensore (es. 4)

void setup() {
  Serial.begin(9600);
  analogReference(EXTERNAL);
  pinMode(TRIG, OUTPUT);
  pinMode(ECHO, INPUT);
  digitalWrite(TRIG, LOW);
  Serial.println("Tempo (s)   Distanza (cm)");
  float distanza=0.;
  float d_somma=0.;
  float t_somma=0.;
  float temperatura=0.;
  float t=0.; 
  int i=0;
  int m=0; 
  int rip=-;                        // Al posto dei trattini, inserire il numero di misure delle quali viene calcolata la media ogni volta (es. 10)
  for (m=0; m<--; m++) {            // Al posto dei trattini, inserire il numero di medie che si vuole calcolare (es. 10)
    for(i=0; i<rip; i++){
      digitalWrite(TRIG, HIGH);  
      delayMicroseconds(10);
      digitalWrite(TRIG, LOW);
      unsigned long t0 = micros();
      unsigned long Dt = pulseIn(ECHO, HIGH);
      unsigned long t1 = micros();
      distanza = 343.*Dt*(1.e-4)/2.;
      t = ((t0+t1)/2.)*(1.e-6);
      d_somma += distanza;
      t_somma += t;
      delay(10);
    }
    Serial.print(t_somma/rip);
    Serial.print("  ");
    Serial.println(d_somma/rip);
    d_somma=0.;
    t_somma=0.;
    delay(10);                    // Il numero tra parentesi indica i microsecondi di pausa tra una media e la successiva; possono essere modificati a piacere per accorciare o allungare la pausa
  }
}

void loop() {
  
}
