// Prima di caricare il programma, selezionare Strumenti > Scheda > Arduino Uno e Strumenti > Porta > selezionare la porta visibile
// Caricare il programma finito su Arduino schiacciando la freccetta in alto a sinistra
// Visualizzare il monitor seriale schiacciando la lente d'ingrandimento in alto a destra

// MEDIE DI MISURE DI INCLINAZIONE
// Questo programma effettua un dato numero di misure di inclinazione, ne calcola la media e poi riprende da capo.
// In tutto viene calcolato un numero pressoché infinito di medie.
// Le misure iniziano non appena si apre il monitor seriale. Per interromperle, togliere la spunta dallo scorrimento automatico. Ogni media viene stampata sul monitor seriale.

#include <MPU6050_tockn.h>
#include <Wire.h>

MPU6050 mpu6050(Wire);

void setup() {
  Serial.begin(9600);
  Wire.begin();
  mpu6050.begin();
  mpu6050.calcGyroOffsets(true);
}

unsigned long t1, dt;
float y;

void loop() {
  int i=0;
  float sumY=0.;
  mpu6050.update();
  dt = millis() - t1;
  if (dt > 200) {
    t1 = millis();
    for(i=0;i<10;i++){
      y = mpu6050.getAngleY();
      sumY += y;
    }
    Serial.print("\tangleY : ");
    Serial.println(sumY/10);
  }
}
