// Prima di caricare il programma, selezionare Strumenti > Scheda > Arduino Uno e Strumenti > Porta > selezionare la porta visibile
// Caricare il programma finito su Arduino schiacciando la freccetta in alto a sinistra
// Visualizzare il monitor seriale schiacciando la lente d'ingrandimento in alto a destra

// MEDIE DI MISURE DI INCLINAZIONE CON DISTANZA E CON TEMPO
// Questo programma effettua un dato numero di misure di distanza e di inclinazione, ne calcola la media, mostra l'istante di tempo medio di esecuzione del gruppo di misure e poi riprende da capo.
// In tutto viene calcolato un numero pressoché infinito di medie.
// Le misure iniziano non appena si apre il monitor seriale. Per interromperle, togliere la spunta dallo scorrimento automatico. Ogni media e il suo tempo vengono stampatae sul monitor seriale.

#include <MPU6050_tockn.h>
#include <Wire.h>

MPU6050 mpu6050(Wire);

#define TRIG 3   // Al posto dei trattini, inserire il numero del pin di Arduino a cui è collegato TRIG del sensore (es. 2)
#define ECHO 2   // Al posto dei trattini, inserire il numero del pin di Arduino a cui è collegato ECHO del sensore (es. 4)

void setup() {
  Serial.begin(9600);
  analogReference(EXTERNAL);
  pinMode(TRIG, OUTPUT);
  pinMode(ECHO, INPUT);
  digitalWrite(TRIG, LOW);
  Serial.begin(9600);
  Wire.begin();
  mpu6050.begin();
  mpu6050.calcGyroOffsets(true);
  Serial.println(" ");
  Serial.println("Tempo (s)   Distanza (cm)   Inclinazione (°)");
  
}

unsigned long t1, dt;
float y;

void loop() {
  int i=0;
  float sumY=0.;
  float distanza=0.;
  float d_somma=0.;
  float t_somma=0.;
  float temperatura=0.;
  float t=0.;
  int rip=10;
    mpu6050.update();
    dt = millis() - t1;
    if (dt > 200) {
      t1 = millis();
      for(i=0; i<rip; i++){
      digitalWrite(TRIG, HIGH);  
      delayMicroseconds(10);
      digitalWrite(TRIG, LOW);
      unsigned long t0 = micros();
      unsigned long Dt = pulseIn(ECHO, HIGH);
      unsigned long t1 = micros();
      distanza = 343.*Dt*(1.e-4)/2;
      t = ((t0+t1)/2.)*(1.e-6);
      d_somma += distanza;
      t_somma += t;
      y = mpu6050.getAngleY();
      sumY += y;
      delay(10);
    }
    Serial.print(t_somma/rip);
    Serial.print("  ");
    Serial.print(d_somma/rip);
    Serial.print("  ");
    Serial.println(sumY/10);
    d_somma=0.;
    t_somma=0.;
    sumY=0.;
    delay(10);    
  }
}
